unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, _PuzzleTable, Grids, JPEG, StdCtrls, ExtCtrls, Spin, Buttons,
  ExtDlgs, ComCtrls, FileCtrl, XPMan;

type
  TfrmMain = class(TForm)
    Panel2: TPanel;
    SpinEdit1: TSpinEdit;
    btnRestart: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    Image1: TImage;
    lblPicture: TStaticText;
    FileListBox1: TFileListBox;
    btnPicts: TBitBtn;
    btnNums: TBitBtn;
    pnlPuzzle: TPanel;
    Label1: TLabel;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure btnRestartClick(Sender: TObject);
    procedure btnPictsClick(Sender: TObject);
    procedure btnNumsClick(Sender: TObject);
  private
    { Private declarations }
    FImageFullFileName: string;
    FWorkArea: TNumberPuzzle;
    FNumbers: boolean;
    procedure SetPictureFile( sFN: string);
    procedure RestartGame;
    function SelectPicture: boolean;
    function PitajZaRestart: boolean;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

const
  cImagePath = '.\pictures';

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Randomize;
  pnlPuzzle.SetBounds(0,0,600, 600); // odredjuje velicinu slike PUZZLE
  ClientHeight := pnlPuzzle.Height;
  self.ClientWidth := pnlPuzzle.Width + self.Panel2.Width;

  FNumbers := false;

  try
    with FileListBox1  do
    begin

      Directory := ExtractFilePath( Application.ExeName) + cImagePath;
      SetPictureFile( Directory + '\'+
        Items.Strings[ random( Items.Count)]);
    end;
  except
    FNumbers := true;
  end;

  RestartGame;
end;


procedure TfrmMain.RestartGame;
begin
  if Assigned( FWorkArea) then
    FWorkArea.Free;

  try
    FWorkArea := MakePuzzle( FNumbers, FImageFullFileName);
    with FWorkArea do
    begin
      Parent := pnlPuzzle;
      //Align := alClient;
      SplitCount := SpinEdit1.Value;
      Restart;
    end;
  except
    FWorkArea := nil;
  end;
end;

procedure TfrmMain.btnRestartClick(Sender: TObject);
begin
  RestartGame;
end;

procedure TfrmMain.SetPictureFile(sFN: string);
begin
  FImageFullFileName := sFN;
  lblPicture.Caption := Format( '[%s]',
     [ExtractFileName(FImageFullFileName)]);
  try
    self.Image1.Picture.LoadFromFile( sFN);
  except

  end;
end;

function TfrmMain.SelectPicture: boolean;
begin
  Result := false;
  with OpenPictureDialog1  do
  begin
    InitialDir := ExtractFilePath( Application.ExeName)+ 'Pictures';
    FileName := self.FImageFullFileName;
    if Execute then
    begin
      Result := true;
      SetPictureFile( FileName);
    end;
  end;
end;

procedure TfrmMain.btnPictsClick(Sender: TObject);
begin
  if SelectPicture then
  begin
    FNumbers := false;
    RestartGame;
  end;
end;

function TfrmMain.PitajZaRestart: boolean;
begin
  Result := (MessageDLG('Restart game?', mtConfirmation,
    [mbYes, mbNo], 0) = mrYes);
end;

procedure TfrmMain.btnNumsClick(Sender: TObject);
begin
  if PitajZaRestart then
  begin
    FNumbers := true;
    RestartGame;
  end;
end;

end.


